'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var getGroups = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return getJson('/v2/groups');

          case 2:
            return _context.abrupt('return', _context.sent.apps);

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getGroups() {
    return _ref.apply(this, arguments);
  };
}();

var getOrigin = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2(appId) {
    var app, _app$tasks$, host, ports, translateHost;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return getJson('/v2/apps' + appId);

          case 2:
            app = _context2.sent.app;
            _app$tasks$ = app.tasks[0], host = _app$tasks$.host, ports = _app$tasks$.ports;
            translateHost = _proxyTable2.default[host];
            return _context2.abrupt('return', translateHost + ':' + ports[0]);

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getOrigin(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var marathon = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee3(keyword) {
    var apps, targetApp;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getGroups();

          case 2:
            apps = _context3.sent;
            targetApp = apps.find(function (it) {
              return it.id.indexOf(keyword) !== -1;
            });

            if (!targetApp) {
              _context3.next = 10;
              break;
            }

            _context3.next = 7;
            return getOrigin(targetApp.id);

          case 7:
            return _context3.abrupt('return', _context3.sent);

          case 10:
            console.error('not found app');
            return _context3.abrupt('return', '');

          case 12:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function marathon(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

var _proxyTable = require('./proxyTable');

var _proxyTable2 = _interopRequireDefault(_proxyTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var http = require('http');


function authOpt(path) {
  var options = {
    host: '172.16.7.23',
    port: 8080,
    path: '',
    headers: {
      'Authorization': 'Basic ' + new Buffer('wisedu' + ':' + 'wiseduauth').toString('base64')
    }

  };
  return Object.assign({}, options, { path: path });
}

function getJson(path) {
  return new Promise(function (resolve, reject) {
    http.get(authOpt(path), function (res) {
      var body = "";
      res.on('data', function (data) {
        body += data;
      });
      res.on('end', function (_) {
        resolve(JSON.parse(body));
      });
      res.on('error', function (err) {
        reject(err);
      });
    });
  });
}

exports.default = marathon;