'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUnusedPort = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var getUnusedPort = exports.getUnusedPort = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var checkportIsOccupied = function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(port) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return portIsOccupied(port);

              case 2:
                if (!_context.sent) {
                  _context.next = 8;
                  break;
                }

                _context.next = 5;
                return checkportIsOccupied(port + 1);

              case 5:
                return _context.abrupt('return', _context.sent);

              case 8:
                return _context.abrupt('return', port);

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function checkportIsOccupied(_x2) {
        return _ref2.apply(this, arguments);
      };
    }();

    var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 8080;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return checkportIsOccupied(start);

          case 2:
            return _context2.abrupt('return', _context2.sent);

          case 3:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getUnusedPort() {
    return _ref.apply(this, arguments);
  };
}();

exports.portIsOccupied = portIsOccupied;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var net = require('net');

function portIsOccupied(port) {
  // 创建服务并监听该端口
  return new Promise(function (resolve, reject) {
    var server = net.createServer().listen(port, '0.0.0.0');
    server.on('listening', function () {
      // 执行这块代码说明端口未被占用
      server.close(); // 关闭服务
      resolve(false);
    });

    server.on('error', function (err) {
      if (err.code === 'EADDRINUSE') {
        // 端口已经被使用
        resolve(true);
      }
    });
  });
}