'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _gulp = require('gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _gulpConnect = require('gulp-connect');

var _gulpConnect2 = _interopRequireDefault(_gulpConnect);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _httpProxyMiddleware = require('http-proxy-middleware');

var _httpProxyMiddleware2 = _interopRequireDefault(_httpProxyMiddleware);

var _marathon = require('../helpers/marathon');

var _marathon2 = _interopRequireDefault(_marathon);

var _utils = require('../helpers/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

_gulp2.default.task('connect', _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
  var port, i;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.t0 = _config2.default.server.port;

          if (_context.t0) {
            _context.next = 5;
            break;
          }

          _context.next = 4;
          return (0, _utils.getUnusedPort)();

        case 4:
          _context.t0 = _context.sent;

        case 5:
          port = _context.t0;
          i = 0;

        case 7:
          if (!(i < _config2.default.proxy.length)) {
            _context.next = 16;
            break;
          }

          if (!(_config2.default.proxy[i].marathonID && !_config2.default.proxy[i].target)) {
            _context.next = 13;
            break;
          }

          _context.next = 11;
          return (0, _marathon2.default)(_config2.default.proxy[i].marathonID);

        case 11:
          _context.t1 = _context.sent;
          _config2.default.proxy[i].target = 'http://' + _context.t1;

        case 13:
          i++;
          _context.next = 7;
          break;

        case 16:
          _gulpConnect2.default.server({
            root: _config2.default.dest,
            port: port,
            livereload: true,
            middleware: function middleware(connect, opt) {
              var proxys = [];

              if (_config2.default.proxy) {
                for (var _i = 0; _i < _config2.default.proxy.length; _i++) {
                  var headers = Object.assign({
                    Connection: 'keep-alive'
                  }, _config2.default.proxy[_i].headers);
                  proxys.push((0, _httpProxyMiddleware2.default)(_config2.default.proxy[_i].source, {
                    target: _config2.default.proxy[_i].target,
                    changeOrigin: true,
                    secure: false,
                    headers: headers
                  }));
                }
              }
              return proxys;
            }
          });

        case 17:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
})));

exports.default = _gulpConnect2.default;